#ifndef _Tuner_T_H
#define _Tuner_T_H

#include "Prefix.h"
#include "OS_Thread.h"
#include "TC90522_T.h"

namespace EARTH {
	class Tuner_T {
	public:
		Tuner_T(TC90522_T *tc90522) : mTC90522(tc90522)
		{
			_ASSERT(mTC90522);
		}

		~Tuner_T()
		{
		}

	protected:
		TC90522_T	*const mTC90522;

		void GetChannelFrequency(uint32 channel, bool *catv, uint32 *number, uint32 *frequency) const
		{
			sint32 frequencyOffset = 0;
			if (12 <= channel) frequencyOffset += 2;
			if (17 <= channel) frequencyOffset -= 2;
			if (63 <= channel) frequencyOffset += 2;
			*frequency = 93 + channel * 6 + frequencyOffset;

			static const uint8 TABLE[][3] = {
				{   2,  0,   3 },
				{  12,  1,  22 },
				{  21,  0,  12 },
				{  62,  1,  63 },
				{ 112,  0,  62 }
			};

			for (uint32 i=0; i<sizeof(TABLE)/sizeof(*TABLE); i++) {
				if (channel <= TABLE[i][0]) {
					_ASSERT(catv); *catv = TABLE[i][1] ? true : false;
					_ASSERT(number); *number = channel + TABLE[i][2] - TABLE[i][0];
					break;
				}
			}
		}
	};
}

#endif
